#include "stdafx.h"
#include "doublevect.h"

#define DEBUG

using namespace std;

doublevect::doublevect(int n)
{
	this->n = n;
	p = new double[n];
	
#ifdef DEBUG
	cout << "doublevect created " << n << endl;
#endif
}


doublevect::~doublevect()
{
	delete p;
#ifdef DEBUG
	cout << "doublevect deleted " << n << endl;
#endif
}

void doublevect::set(int i, double x)
{
	if (i >= 0 && i < n) p[i] = x;
	else throw out_of_range("Error in doublevect::set");
}

double doublevect::get(int i)
{
	if (i >= 0 && i < n) return p[i];
	else throw out_of_range("Error in doublevect::get");
}

double & doublevect::operator[](int i)
{   //  []    i-  
	if (i >= 0 && i < n) return p[i];
	else throw out_of_range("Error in doublevect::[]");
}

void doublevect::operator=(double x)
{
	for (int i = 0; i < n; i++) p[i] = x;
}

doublevect & doublevect::operator=(doublevect & a)
{
  if (n == a.n) for (int i = 0; i < n; i++) p[i] = a.p[i];
  else throw std::out_of_range("Different size!");
}