template <class T> class univector
{
protected:
	int n; //  
	T *p; //    
public:
	univector(int n = 3);
	~univector();
	T & operator[](int i);
	int N() { return n; }
	void resize(int m);
	void operator=(T x);
};

template <class T> univector<T>::univector(int n)
{
	this->n = n;
	p = new T[n];
	for (int i = 0; i < n; i++) p[i] = 0;
	#ifdef debug
		std::cout << "univector " << n << " created\n";
	#endif
}

template <class T> univector<T>::~univector()
{
#ifdef debug
	std::cout << "univector " << n << " deleted\n";
#endif
}


template <class T> T & univector<T>::operator[](int i)
{
	if (i >= 0 && i < n) return p[i];
	else throw std::out_of_range("Vector out of range");
}

template <class T> void univector<T>::resize(int m)
{
	T *q = new T[m];
	for (int i = 0; i < m; i++) q[i] = 0;
	for (int i = 0; i < (m < n ? m : n); i++) q[i] = p[i];
	p = q;
	n = m;
}

template <class T>
void univector<T>::operator=(T x)
{
	for (int i = 0; i < n; i++) p[i] = x;
}

template <class T>
std::ostream & operator << (std::ostream & stream, univector<T>  obj)
{
	stream << obj.N() << std::endl;
	for (int i = 0; i < obj.N(); i++)
		stream << obj[i] << " ";
	stream << std::endl;
	return stream;
}